package com.loafle.overflow.module.sensor.service;

import com.loafle.overflow.module.meta.model.MetaSensorItem;
import com.loafle.overflow.module.sensor.model.Sensor;
import com.loafle.overflow.module.sensor.model.SensorItem;
import com.loafle.overflow.spring.AppConfig;
import com.loafle.overflow.spring.JdbcConfiguration;
import com.loafle.overflow.spring.MailConfiguration;
import org.codehaus.jackson.map.ObjectMapper;
import org.junit.Assert;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.io.IOException;
import java.util.Date;
import java.util.List;

/**
 * Created by insanity on 17. 6. 28.
 */
@Ignore
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfig.class, JdbcConfiguration.class, MailConfiguration.class})
public class SensorItemServiceTest {
    @Autowired
    SensorItemService sensorItemService;

    @Test
    public void regist() throws Exception {
        SensorItem sensorItem = new SensorItem();
        sensorItem.setCreateDate(new Date());
        MetaSensorItem item = new MetaSensorItem();
        item.setId(1);
        Sensor sensor = new Sensor();
        sensor.setId(1);
        sensorItem.setItem(item);
        sensorItem.setSensor(sensor);

        SensorItem res = this.sensorItemService.regist(sensorItem);
        Assert.assertNotNull(res);
    }

    @Test
    public void read() throws Exception {
        SensorItem res = this.sensorItemService.read("1");
        Assert.assertNotNull(res);
    }

    @Test
    public void readAllBySensor() throws IOException {
        Sensor sensor = new Sensor();
        sensor.setId(1);
        List<SensorItem> sensorItems = this.sensorItemService.readAllBySensor(sensor);

        ObjectMapper objectMapper = new ObjectMapper();
        String json = objectMapper.writeValueAsString(sensorItems);
        System.out.println(json);
    }
}
